/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
if(void 0===AWS)throw new Error("AWS SDK must be loaded before loading the Sync Manager.");AWS.CognitoSyncManager=function(e){e=e||{};var t="CognitoJavaScriptSDK/1";this.provider=AWS.config.credentials,this.identityPoolId=this.provider.params.IdentityPoolId,this.region=AWS.config.region,this.logger=e.log,"function"!=typeof this.logger&&(this.logger=function(){}),this.local=new AWS.CognitoSyncManager.LocalStorage({DataStore:AWS.CognitoSyncManager.StoreLocalStorage}),this.remote=new AWS.CognitoSyncManager.RemoteStorage(this.identityPoolId,this.provider),this.remote.setUserAgent(t)},AWS.CognitoSyncManager.prototype.openOrCreateDataset=function(e,t){var n=this,i=new RegExp("^[a-zA-Z0-9_.:-]{1,128}$");i.test(e)?this.local.createDataset(this.getIdentityId(),e,function(e,i){return e?t(e,null):void t(null,new AWS.CognitoSyncManager.Dataset(i,n.provider,n.local,n.remote,n.logger))}):t(new Error("Dataset name must match the pattern "+i.toString()))},AWS.CognitoSyncManager.prototype.listDatasets=function(e){this.local.getDatasets(this.getIdentityId(),e)},AWS.CognitoSyncManager.prototype.refreshDatasetMetadata=function(e){var t=this;this.remote.getDatasets(function(n,i){var a=[],s=function(e){t.local.updateDatasetMetadata(t.getIdentityId(),e,r)},r=function(t,n){a.push(n),i.length>0?s(i.shift()):e(null,a)};i.length>0?s(i.shift(),e):e(null,[])})},AWS.CognitoSyncManager.prototype.wipeData=function(){this.provider.clearCachedId(),this.local.wipeData()},AWS.CognitoSyncManager.prototype.getIdentityId=function(){return this.provider.identityId},/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.Conflict=function(){var e=function(e,t){if(!e||!t)throw new Error("Remote and local records cannot be null.");if(!e.getKey||!t.getKey)throw new Error("Records are not record objects.");if(e.getKey()!==t.getKey())throw new Error("Remote and local keys do not match.");this.key=e.getKey(),this.remoteRecord=e,this.localRecord=t};return e.prototype.getKey=function(){return this.key},e.prototype.getRemoteRecord=function(){return this.remoteRecord},e.prototype.getLocalRecord=function(){return this.localRecord},e.prototype.resolveWithRemoteRecord=function(){return this.remoteRecord.setModified(!1),this.remoteRecord},e.prototype.resolveWithLocalRecord=function(){return this.localRecord.setSyncCount(this.remoteRecord.getSyncCount()),this.localRecord.setModified(!0),this.localRecord},e.prototype.resolveWithValue=function(e){return new AWS.CognitoSyncManager.Record({Key:this.remoteRecord.getKey(),Value:e,SyncCount:this.remoteRecord.getSyncCount(),LastModifiedDate:new Date,LastModifiedBy:this.localRecord.getLastModifiedBy(),DeviceLastModifiedDate:new Date,Modified:!0})},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.Dataset=function(){var e=function(e,t,n,i,a){this.MAX_RETRY=3,this.datasetName=e,this.provider=t,this.local=n,this.remote=i,this.logger=a||function(){}};return e.prototype.validateKey=function(e){var t=new RegExp("^[a-zA-Z0-9_.:-]{1,128}$");return t.test(e)},e.prototype.put=function(e,t,n){return this.validateKey(e)?void this.local.putValue(this.getIdentityId(),this.datasetName,e,t,n):n(new Error("Invalid key."))},e.prototype.remove=function(e,t){return this.validateKey(e)?void this.local.putValue(this.getIdentityId(),this.datasetName,e,null,t):t(new Error("Invalid key."))},e.prototype.get=function(e,t){return this.validateKey(e)?void this.local.getValue(this.getIdentityId(),this.datasetName,e,t):t(new Error("Invalid key."))},e.prototype.getAllRecords=function(e){this.local.getRecords(this.getIdentityId(),this.datasetName,e)},e.prototype.getDataStorage=function(e){this.getDatasetMetadata(function(t,n){return t?e(t):n?e(null,n.getDataStorage()):e(null,0)})},e.prototype.isChanged=function(e,t){return this.validateKey(e)?void this.local.getRecord(this.getIdentityId(),this.datasetName,e,function(e,n){t(null,n&&n.isModified())}):t(new Error("Invalid key."))},e.prototype.getDatasetMetadata=function(e){this.local.getDatasetMetadata(this.getIdentityId(),this.datasetName,e)},e.prototype.resolve=function(e,t){this.local.putRecords(this.getIdentityId(),this.datasetName,e,t)},e.prototype.putAll=function(e,t){var n=!0;for(var i in e)e.hasOwnProperty(i)&&(this.validateKey(i)||(n=!1));return n?void this.local.putAllValues(this.getIdentityId(),this.datasetName,e,t):t(new Error("Object contains invalid keys."))},e.prototype.getAll=function(e){var t,n={};this.local.getRecords(this.getIdentityId(),this.datasetName,function(i,a){if(i)return e(i);for(var s in a)a.hasOwnProperty(s)&&(t=a[s],t.isDeleted()||(n[t.getKey()]=t.getValue()));e(null,n)})},e.prototype.getIdentityId=function(){return this.provider.identityId},e.prototype.getModifiedRecords=function(e){this.local.getModifiedRecords(this.getIdentityId(),this.datasetName,e)},e.prototype.getLocalMergedDatasets=function(e){var t,n=[],i=this.datasetName+".";this.local.getDatasets(this.getIdentityId(),function(a,s){for(var r in s)s.hasOwnProperty(r)&&(t=s[r],0===t.getDatasetName().indexOf(i)&&n.push(t.getDatasetName()));e(null,n)})},e.prototype.synchronize=function(e,t){var n=this;return e=e||{},e.onSuccess=e.onSuccess||function(){},e.onFailure=e.onFailure||function(){},e.onConflict=e.onConflict||function(e,t,n){return n(!1)},e.onDatasetDeleted=e.onDatasetDeleted||function(e,t,n){return n(!1)},e.onDatasetsMerged=e.onDatasetsMerged||function(e,t,n){return n(!1)},void 0===t&&(t=this.MAX_RETRY),n.logger("Starting synchronization... (retires: "+t+")"),0>t?e.onFailure(new Error("Synchronized failed: exceeded maximum retry count.")):void this.getLocalMergedDatasets(function(i,a){return i&&e.onFailure(i),n.logger("Checking for locally merged datasets... found "+a.length+"."),a.length>0?(n.logging("Deferring to .onDatasetsMerged."),e.onDatasetsMerged(n,a,function(i){return i?n.synchronize(e,--t):e.onFailure(new Error("Synchronization cancelled by onDatasetsMerged() callback returning false."))})):void n.local.getLastSyncCount(n.getIdentityId(),n.datasetName,function(i,a){return i?e.onFailure(i):(n.logger("Detecting last sync count... "+a),void n.remote.listUpdates(n.datasetName,a,function(i,s){if(i)return e.onFailure(i);n.logger("Fetch remote updates... found "+s.records.length+".");var r=s.getMergedDatasetNameList();if(n.logger("Checking for remote merged datasets... found "+r.length+"."),r.length>0)return n.logger("Deferring to .onDatasetsMerged."),e.onDatasetsMerged(n,r,function(i){i?n._synchronizeInternal(e,--t):e.onFailure(new Error("Cancelled due to .onDatasetsMerged result."))});if(0!==a&&!s||s.isDeleted())return e.onDatasetDeleted(n,s.getDatasetName(),function(i){return n.logging("Dataset should be deleted. Deferring to .onDatasetDeleted."),i?(n.logging(".onDatasetDeleted returned true, purging dataset locally."),n.local.purgeDataset(n.getIdentityId(),n.datasetName,function(i){return i?e.onFailure(i):n._synchronizeInternal(e,--t)})):(n.logging(".onDatasetDeleted returned false, cancelling sync."),e.onFailure(new Error("Cancelled due to .onDatasetDeleted result.")))});var o=s.getRecords(),l=s.getSyncCount(),c=s.getSyncSessionToken();n.logger("Checking for remote updates since last sync count... found "+o.length+"."),o.length>0?n._synchronizeResolveLocal(o,function(i,s){return i?e.onFailure(i):(n.logger("Checking for conflicts... found "+s.length+"."),void(s.length>0?(n.logger("Conflicts detected. Deferring to .onConflict."),e.onConflict(n,s,function(i){return i?void n._synchronizePushRemote(c,a,function(){return n.synchronize(e,--t)}):(n.logger(".onConflict returned false. Cancelling sync."),e.onFailure(new Error("Sync cancelled. Conflict callback returned false.")))})):(n.logger("No conflicts. Updating local records."),n.local.putRecords(n.getIdentityId(),n.datasetName,o,function(i){return i?e.onFailure(i):void n.local.updateLastSyncCount(n.getIdentityId(),n.datasetName,l,function(i){return i?e.onFailure(i):(n.logger("Finished resolving records. Restarting sync."),n.synchronize(e,--t))})}))))}):(n.logger("Nothing updated remotely. Pushing local changes to remote."),n._synchronizePushRemote(c,l,function(i){return i?(n.logger("Remote push failed. Likely concurrent sync conflict. Retrying..."),n.synchronize(e,--t)):(n.logger("Sync successful."),e.onSuccess(n,o))}))}))})})},e.prototype._synchronizeResolveLocal=function(e,t){var n=this,i=[];return e&&e.length>0?void n.local.getRecords(n.getIdentityId(),n.datasetName,function(n,a){var s,r,o,l={};for(s=0;s<a.length;s++)l[a[s].getKey()]=a[s];for(s=0;s<e.length;s++)r=e[s].getKey(),o=l[r],o&&o.isModified()&&o.getValue()!==e[s].getValue()&&i.push(new AWS.CognitoSyncManager.Conflict(e[s],o));return t(null,i)}):t(null,i)},e.prototype._synchronizePushRemote=function(e,t,n){var i=this;this.getModifiedRecords(function(t,a){return a.length>0?void i.remote.putRecords(i.datasetName,a,e,function(e,t){e&&n(e),i.local.putRecords(i.getIdentityId(),i.datasetName,t,function(e){if(e)return n(e);var a=0;for(var s in t)t.hasOwnProperty(s)&&(a=a<t[s].getSyncCount()?t[s].getSyncCount():a);i.local.updateLastSyncCount(i.getIdentityId(),i.datasetName,a,function(e){return e?n(e):n(null,!0)})})}):n(null,!0)})},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.DatasetMetadata=function(){var e=function(e){if(e=e||{},this.datasetName=e.DatasetName||"",this.creationDate=new Date(e.CreationDate)||new Date,this.lastModifiedDate=new Date(e.LastModifiedDate)||new Date,this.lastModifiedBy=e.LastModifiedBy||"",this.dataStorage=e.DataStorage||0,this.recordCount=e.NumRecords||0,this.lastSyncCount=e.LastSyncCount||0,this.lastSyncDate=new Date(e.LastSyncDate||null)||new Date,this.dataStorage<0)throw new RangeError("Storage size cannot be negative.");if(this.recordCount<0)throw new RangeError("Record count cannot be negative.")};return e.prototype.getDatasetName=function(){return this.datasetName},e.prototype.setDatasetName=function(e){return this.datasetName=e,this},e.prototype.getCreationDate=function(){return this.creationDate},e.prototype.setCreationDate=function(e){return this.creationDate=new Date(e),this},e.prototype.getLastModifiedDate=function(){return this.lastModifiedDate},e.prototype.setLastModifiedDate=function(e){return this.lastModifiedDate=new Date(e),this},e.prototype.getLastModifiedBy=function(){return this.lastModifiedBy},e.prototype.setLastModifiedBy=function(e){return this.lastModifiedBy=e,this},e.prototype.getDataStorage=function(){return this.dataStorage},e.prototype.setDataStorage=function(e){return this.dataStorage=e,this},e.prototype.getRecordCount=function(){return this.recordCount},e.prototype.setRecordCount=function(e){return this.recordCount=e,this},e.prototype.getLastSyncCount=function(){return this.lastSyncCount},e.prototype.setLastSyncCount=function(e){return this.lastSyncCount=e,this},e.prototype.getLastSyncDate=function(){return this.lastSyncDate},e.prototype.setLastSyncDate=function(e){return this.lastSyncDate=e,this},e.prototype.toString=function(){return JSON.stringify(this.toJSON())},e.prototype.toJSON=function(){return{DatasetName:this.datasetName,CreationDate:this.creationDate,LastModifiedDate:this.lastModifiedDate,LastModifiedBy:this.lastModifiedBy,DataStorage:this.dataStorage,NumRecords:this.recordCount,LastSyncCount:this.lastSyncCount,LastSyncDate:this.lastSyncDate}},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.DatasetUpdates=function(){var e=function(e){this.datasetName=e,this.records=[],this.syncCount=0,this.syncSessionToken="",this.exists=!0,this.deleted=!1,this.mergedDatasetNameList=[]};return e.prototype.getDatasetName=function(){return this.datasetName},e.prototype.setDatasetName=function(e){return this.datasetName=e,this},e.prototype.getRecords=function(){return this.records},e.prototype.addRecord=function(e){return this.records.push(e),this},e.prototype.getSyncCount=function(){return this.syncCount},e.prototype.setSyncCount=function(e){return this.syncCount=e,this},e.prototype.getSyncSessionToken=function(){return this.syncSessionToken},e.prototype.setSyncSessionToken=function(e){return this.syncSessionToken=e,this},e.prototype.isExists=function(){return this.exists},e.prototype.setExists=function(e){return this.exists=e,this},e.prototype.isDeleted=function(){return this.deleted},e.prototype.setDeleted=function(e){return this.deleted=e,this},e.prototype.getMergedDatasetNameList=function(){return this.mergedDatasetNameList},e.prototype.setMergedDatasetNameList=function(e){return this.mergedDatasetNameList=e,this},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.LocalStorage=function(){var e=function(e){e=e||{},this.store=null,this.meta=null,this.store=e.DataStore?new e.DataStore:new AWS.CognitoSyncManager.StoreInMemory};return e.prototype.getMetadataKey=function(e,t){return e+"."+t},e.prototype.loadMetadataCache=function(e,t){var n=this;this.store.get("_internal","_metadata",e,function(e,i){return e?t(e,null):(i||(i={}),n.meta=i,void t(null,i))})},e.prototype.saveMetadataCache=function(e,t,n){this.store.set("_internal","_metadata",e,t,function(e){return e?n(e):n(null,t)})},e.prototype.createDataset=function(e,t,n){var i=this;return this.getDatasetMetadata(e,t,function(a,s){var r=(new Date).getTime();s?n(null,t):(s=new AWS.CognitoSyncManager.DatasetMetadata({DatasetName:t,CreationDate:r,LastModifiedDate:r}),i.setDatasetMetadata(e,t,s,function(){}),n(null,t))}),this},e.prototype.getDatasetMetadata=function(e,t,n){var i=this.getMetadataKey(e,t);return null!==this.meta?this.meta[i]?n(null,new AWS.CognitoSyncManager.DatasetMetadata(this.meta[i])):n(null,void 0):this.loadMetadataCache(e,function(e,t){t[i]?n(null,new AWS.CognitoSyncManager.DatasetMetadata(t[i])):n(null,void 0)}),this},e.prototype.setDatasetMetadata=function(e,t,n,i){return this.meta[this.getMetadataKey(e,t)]=n.toJSON(),this.saveMetadataCache(e,this.meta,i),this},e.prototype.getValue=function(e,t,n,i){this.getRecord(e,t,n,function(e,t){return t?i(null,t.getValue()):i(null,void 0)})},e.prototype.putValue=function(e,t,n,i,a){var s=this;this.getRecord(e,t,n,function(r,o){return o&&o.getValue()==i?a(null,o):(o||(o=new AWS.CognitoSyncManager.Record),o.setKey(n).setValue(i).setModified(!0).setSyncCount(o?o.getSyncCount():0).setDeviceLastModifiedDate(new Date),void s.store.set(e,t,n,o.toJSON(),function(n){return n?a(n):void s.updateLastModifiedTimestamp(e,t,function(e){return a(e,o)})}))})},e.prototype.getValueMap=function(e,t,n){var i,a={};this.getRecords(e,t,function(e,t){for(var s in t)t.hasOwnProperty(s)&&(i=t[s],i.isDeleted()||(a[i.getKey()]=i.getValue()));n(null,a)})},e.prototype.putAllValues=function(e,t,n,i){var a=this,s=[];for(var r in n)n.hasOwnProperty(r)&&s.push(r);var o=function(r){var l;return r?i(r):void(s.length>0?(l=s.shift(),a.putValue(e,t,l,n[l],function(){setTimeout(o,0)})):i(null,!0))};o(null,null)},e.prototype.getDatasets=function(e,t){var n=[];if(null!==this.meta){for(var i in this.meta)this.meta.hasOwnProperty(i)&&n.push(new AWS.CognitoSyncManager.DatasetMetadata(this.meta[i]));return t(null,n)}this.loadMetadataCache(e,function(e,i){for(var a in i)i.hasOwnProperty(a)&&n.push(new AWS.CognitoSyncManager.DatasetMetadata(i[a]));return t(null,n)})},e.prototype.updateDatasetMetadata=function(e,t,n){var i=this;this.getDatasetMetadata(e,t.getDatasetName(),function(a,s){a&&n(a),s||(s=new AWS.CognitoSyncManager.DatasetMetadata),s.setDatasetName(t.getDatasetName()).setCreationDate(t.getCreationDate()).setLastModifiedDate(t.getLastModifiedDate()).setLastModifiedBy(t.getLastModifiedBy()).setLastSyncCount(t.getLastSyncCount()).setRecordCount(t.getRecordCount()).setDataStorage(t.getDataStorage()),i.meta[i.getMetadataKey(e,t.getDatasetName())]=s.toJSON(),i.saveMetadataCache(e,i.meta,function(e){return e?n(e):n(null,s)})})},e.prototype.getRecord=function(e,t,n,i){this.store.get(e,t,n,function(e,t){return t?i(null,new AWS.CognitoSyncManager.Record(t)):i(new Error("Key doesn't exist."),null)})},e.prototype.getRecords=function(e,t,n){var i=[];this.store.getAll(e,t,function(e,t){for(var a in t)t.hasOwnProperty(a)&&i.push(new AWS.CognitoSyncManager.Record(t[a]));n(null,i)})},e.prototype.putRecords=function(e,t,n,i){var a=this;n=n||[];var s=function(){n.length>0&&a.updateAndClearRecord(e,t,n.shift(),function(e){return e?i(e):0===n.length?i(null,!0):void setTimeout(s,0)})};s()},e.prototype.deleteDataset=function(e,t,n){var i=this;this.store.removeAll(e,t,function(a){return a?n(a):void i.getDatasetMetadata(e,t,function(t,a){return t?n(t):(a.setLastModifiedDate(new Date),a.setSyncCount(-1),void i.updateDatasetMetadata(e,a,function(e){return e?n(e):n(null,!0)}))})})},e.prototype.purgeDataset=function(e,t,n){this.deleteDataset(e,t,function(i){i&&n(i),delete this.meta[t],this.saveMetadataCache(e,t,this.meta,function(e,t){n(null,t)})})},e.prototype.getLastSyncCount=function(e,t,n){this.getDatasetMetadata(e,t,function(e,t){return t?n(null,t.getLastSyncCount()):void n(new Error("Dataset doesn't exist."),null)})},e.prototype.getModifiedRecords=function(e,t,n){var i=[];this.getRecords(e,t,function(e,t){for(var a=0;a<t.length;a++)t[a].isModified()&&i.push(t[a]);n(null,i)})},e.prototype.updateLastSyncCount=function(e,t,n,i){var a=this;this.getDatasetMetadata(e,t,function(t,s){t&&i(t),s.setLastSyncCount(n).setLastSyncDate(new Date),a.updateDatasetMetadata(e,s,function(e){e&&i(e),i(null,!0)})})},e.prototype.wipeData=function(e){this.store.wipe(e)},e.prototype.updateLastModifiedTimestamp=function(e,t,n){var i=this;this.getDatasetMetadata(e,t,function(t,a){return t?n(t):(a.setLastModifiedDate(new Date),void i.updateDatasetMetadata(e,a,function(e){return e?n(e):n(null,!0)}))})},e.prototype.removeRecord=function(e,t,n){this.store.remove(e,t,n,function(e){return e?callback(e):callback(null,!0)})},e.prototype.updateAndClearRecord=function(e,t,n,i){this.store.set(e,t,n.getKey(),n.toJSON(),function(e){return e?i(e):i(null,!0)})},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.Record=function(){var e=function(e){e=e||{},this.key=e.Key||"",this.value=e.Value||"",this.syncCount=e.SyncCount||0,this.lastModifiedDate=e.LastModifiedDate?new Date(e.LastModifiedDate):new Date,this.lastModifiedBy=e.LastModifiedBy||"",this.deviceLastModifiedDate=e.DeviceLastModifiedDate?new Date(e.DeviceLastModifiedDate):new Date,this.modified=e.Modified||!1};return e.prototype.getKey=function(){return this.key},e.prototype.setKey=function(e){return this.key=e,this},e.prototype.getValue=function(){return this.value},e.prototype.setValue=function(e){return this.value=e,this},e.prototype.getSyncCount=function(){return this.syncCount},e.prototype.setSyncCount=function(e){return this.syncCount=e,this},e.prototype.getLastModifiedDate=function(){return new Date(this.lastModifiedDate)},e.prototype.setLastModifiedDate=function(e){return this.lastModifiedDate=new Date(e),this},e.prototype.getLastModifiedBy=function(){return this.lastModifiedBy},e.prototype.setLastModifiedBy=function(e){return this.lastModifiedBy=e,this},e.prototype.getDeviceLastModifiedDate=function(){return new Date(this.deviceLastModifiedDate)},e.prototype.setDeviceLastModifiedDate=function(e){return this.deviceLastModifiedDate=new Date(e),this},e.prototype.isModified=function(){return this.modified},e.prototype.setModified=function(e){return this.modified=e,this},e.prototype.isDeleted=function(){return null===this.value},e.prototype.toString=function(){return JSON.stringify(this)},e.prototype.toJSON=function(){return{Key:this.key,Value:this.value,SyncCount:this.syncCount,LastModifiedDate:this.lastModifiedDate,LastModifiedBy:this.lastModifiedBy,DeviceLastModifiedDate:this.deviceLastModifiedDate,Modified:this.modified}},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.RemoteStorage=function(){var e=function(e,t){this.identityPoolId=e,this.provider=t,this.client=new AWS.CognitoSync};return e.prototype.userAgent="",e.prototype.getIdentityId=function(){return this.provider.identityId},e.prototype.getDatasets=function(e){var t=this,n=[],i=null,a=function(e,n){t.client.listDatasets({IdentityId:t.getIdentityId(),IdentityPoolId:t.identityPoolId,MaxResults:64,NextToken:e},n)},s=function(t,r){for(var o=r.Datasets||[],l=0;l<o.length;l++)n.push(new AWS.CognitoSyncManager.DatasetMetadata(o[l]));i=r.NextToken,i?a(i,s):e(null,n)};a(i,s)},e.prototype.listUpdates=function(e,t,n){var i=this,a=null,s=new AWS.CognitoSyncManager.DatasetUpdates(e),r=function(n,a){i.client.listRecords({DatasetName:e,IdentityId:i.getIdentityId(),IdentityPoolId:i.identityPoolId,LastSyncCount:t,MaxResults:250,NextToken:n},a)},o=function(e,t){if(e)return n(e);t=t||{};for(var i,l=t.Records||[],c=0;c<l.length;c++)i=new AWS.CognitoSyncManager.Record(l[c]),i.setModified(!1),s.addRecord(i);s.setSyncSessionToken(t.SyncSessionToken).setSyncCount(t.DatasetSyncCount).setExists(t.DatasetExists).setDeleted(t.DatasetDeletedAfterRequestedSyncCount),t.MergedDatasetNames&&s.setMergedDatasetNameList(t.MergedDatasetNames),a=t.NextToken,a?r(a,o):n(null,s)};r(null,o)},e.prototype.putRecords=function(e,t,n,i){var a,s=this,r=[];for(var o in t)t.hasOwnProperty(o)&&(a=t[o],r.push({Key:a.getKey(),Op:a.getValue()?"replace":"remove",SyncCount:a.getSyncCount(),DeviceLastModifiedDate:a.getDeviceLastModifiedDate(),Value:a.getValue()}));this.client.updateRecords({DatasetName:e,IdentityId:s.getIdentityId(),IdentityPoolId:s.identityPoolId,SyncSessionToken:n,RecordPatches:r},function(t,n){var a="string"==typeof e?e:"(invalid dataset name)";if(t)return i(new Error("Failed to update records in dataset: "+a+" ("+t.message+")"),null);for(var s,r=[],o=0;o<n.Records.length;o++)s=new AWS.CognitoSyncManager.Record(n.Records[o]),s.setModified(!1),r.push(s);return i(null,r)})},e.prototype.deleteDataset=function(e,t){this.client.deleteDataset({DatasetName:e,IdentityId:this.getIdentityId(),IdentityPoolId:this.identityPoolId},function(e,n){return e?t(new Error("Failed to delete dataset."),null):t(null,n)})},e.prototype.getDatasetMetadata=function(e,t){this.client.describeDataset({DatasetName:e,IdentityId:this.getIdentityId(),IdentityPoolId:this.identityPoolId},function(e,n){return e?t(new Error("Failed to get dataset metadata."),null):t(null,new AWS.CognitoSyncManager.DatasetMetadata(n.Dataset))})},e.prototype.setUserAgent=function(e){this.userAgent=e},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.StoreInMemory=function(){var e=function(){this.store={}};return e.prototype.makeKey=function(e,t){return e+"."+t},e.prototype.get=function(e,t,n,i){var a=this.makeKey(e,t);return e&&t?this.store[a]&&this.store[a][n]?i(null,this.store[a][n]):i(null,void 0):i(new Error("You must provide an identity id and dataset name."),null)},e.prototype.getAll=function(e,t,n){var i=this.makeKey(e,t);return e&&t?n(null,this.store[i]):n(new Error("You must provide an identity id and dataset name."),null)},e.prototype.set=function(e,t,n,i,a){var s=this.makeKey(e,t),r=this.store[s]||{};return r[n]=i,this.store[s]=r,a(null,r)},e.prototype.setAll=function(e,t,n,i){var a=this.makeKey(e,t);return this.store[a]=n,i(null,n)},e.prototype.remove=function(e,t,n,i){var a=this.makeKey(e,t),s=JSON.parse(this.store[a]);return s||(s={}),delete s[n],this.store[a]=JSON.stringify(s),i(null,!0)},e.prototype.removeAll=function(e,t,n){var i=this.makeKey(e,t);return delete this.store[i],n(null,!0)},e.prototype.wipe=function(e){return this.store={},e(null,!0)},e}(),/**
 * Copyright 2014 Amazon.com,
 * Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Amazon Software License (the "License").
 * You may not use this file except in compliance with the
 * License. A copy of the License is located at
 *
 *     http://aws.amazon.com/asl/
 *
 * or in the "license" file accompanying this file. This file is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, express or implied. See the License
 * for the specific language governing permissions and
 * limitations under the License.
 */
AWS=AWS||{},AWS.CognitoSyncManager=AWS.CognitoSyncManager||{},AWS.CognitoSyncManager.StoreLocalStorage=function(){var e=function(){this.store=AWS.CognitoSyncManager.localStorage||window.localStorage};return e.prototype.makeKey=function(e,t){return e+"."+t},e.prototype.get=function(e,t,n,i){var a=this.makeKey(e,t);if(!e||!t)return i(new Error("You must provide an identity id and dataset name."),null);var s=JSON.parse(this.store.getItem(a));return s&&s[n]?i(null,s[n]):i(null,void 0)},e.prototype.getAll=function(e,t,n){var i=this.makeKey(e,t);return e&&t?n(null,JSON.parse(this.store.getItem(i))):n(new Error("You must provide an identity id and dataset name."),null)},e.prototype.set=function(e,t,n,i,a){var s=this.makeKey(e,t),r=JSON.parse(this.store.getItem(s));return r||(r={}),r[n]=i,this.store.setItem(s,JSON.stringify(r)),a(null,r),this},e.prototype.setAll=function(e,t,n,i){var a=this.makeKey(e,t);return this.store.setItem(a,JSON.stringify(n)),i(null,n)},e.prototype.remove=function(e,t,n,i){var a=this.makeKey(e,t),s=JSON.parse(this.store.getItem(a));return s||(s={}),delete s[n],this.store.setItem(a,JSON.stringify(s)),i(null,!0)},e.prototype.removeAll=function(e,t,n){var i=this.makeKey(e,t);return this.store.removeItem(i),n(null,!0)},e.prototype.wipe=function(e){for(var t in this.store)this.store.hasOwnProperty(t)&&-1===t.indexOf("aws.cognito.identity")&&this.store.removeItem(t);return e?e(null,!0):this},e}();